
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ConversationsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const conversations = await db.conversations.create(
            {
                id: data.id || undefined,
        
        conversation_type: data.conversation_type
        ||
        null
            ,
            
        title: data.title
        ||
        null
            ,
            
        last_message_at: data.last_message_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await conversations.setOwner( data.owner || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.conversations.getTableName(),
                belongsToColumn: 'group_image',
                belongsToId: conversations.id,
            },
            data.group_image,
            options,
        );
        

        return conversations;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const conversationsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                conversation_type: item.conversation_type
            ||
            null
            ,
            
                title: item.title
            ||
            null
            ,
            
                last_message_at: item.last_message_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const conversations = await db.conversations.bulkCreate(conversationsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < conversations.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.conversations.getTableName(),
                    belongsToColumn: 'group_image',
                    belongsToId: conversations[i].id,
                },
                data[i].group_image,
                options,
            );
        }
        

        return conversations;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const conversations = await db.conversations.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.conversation_type !== undefined) updatePayload.conversation_type = data.conversation_type;
        
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.last_message_at !== undefined) updatePayload.last_message_at = data.last_message_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await conversations.update(updatePayload, {transaction});

        
        
        if (data.owner !== undefined) {
            await conversations.setOwner(
              
              data.owner,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.conversations.getTableName(),
                belongsToColumn: 'group_image',
                belongsToId: conversations.id,
            },
            data.group_image,
            options,
        );
        

        return conversations;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const conversations = await db.conversations.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of conversations) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of conversations) {
                await record.destroy({transaction});
            }
        });


        return conversations;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const conversations = await db.conversations.findByPk(id, options);

        await conversations.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await conversations.destroy({
            transaction
        });

        return conversations;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const conversations = await db.conversations.findOne(
            { where },
            { transaction },
        );

        if (!conversations) {
            return conversations;
        }

        const output = conversations.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.conversation_members_conversation = await conversations.getConversation_members_conversation({
            transaction
        });
        
        
        output.messages_conversation = await conversations.getMessages_conversation({
            transaction
        });
        
        
        output.calls_conversation = await conversations.getCalls_conversation({
            transaction
        });
        
        
        
        
        
        
        
        output.group_image = await conversations.getGroup_image({
            transaction
        });
        
        
        output.owner = await conversations.getOwner({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'owner',
        
        where: filter.owner ? {
          [Op.or]: [
            { id: { [Op.in]: filter.owner.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.owner.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'group_image',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'conversations',
                        'title',
                        filter.title,
                    ),
                };
            }
            

            
            

            
            if (filter.last_message_atRange) {
                const [start, end] = filter.last_message_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    last_message_at: {
                    ...where.last_message_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    last_message_at: {
                    ...where.last_message_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.conversation_type) {
                where = {
                    ...where,
                conversation_type: filter.conversation_type,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.conversations.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'conversations',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.conversations.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

